Subject: Re: Automating Windows from cygwin
From: Igor Pechtchanski <[email-masked]>
To: [email-masked]
Cc: [email-masked]
Date: Thu, 8 Aug 2002 21:48:33 -0400 (EDT)

On Thu, 1 Aug 2002, Samuel wrote:

> ----- Original Message -----
> From: "James Ganong" <jeg@thunnus>
> To: <[email-masked]>
> Cc: <[email-masked]>
> Sent: Wednesday, July 31, 2002 1:36 PM
> Subject: Automating Windows from cygwin
>
> > I have some scientific instruments that will only talk to
> > a proprietary Windows app, and some Linux programs that
> > analyze the data.
> > I would really like to automate the process of running the Windows
> > program so that the Linux programs could talk to cygwin over the net
> > and get the data.
> > The problem is that the windows app was written long ago,
> > and source is not available.  So I am wondering if there
> > is a way to run an arbitrary windows application and do something
> > like mouse macros from cygwin.
> >
> > Does anybody know of a way to do mouse macros from cygwin, or a way
> > to invoke menu items from a arbitrary windows app from cygwin, or a better
> > way
> > to approach this?  I have the impression that some people do mouse macros
> > via vnc.  Is there some O'Reilly book that I should have read?
>
> If You can't find anything simpler then you could write your own routine
> that uses Windows Hooks to do that. You probably do not need a "mouse
> macro"; you probably just need to issue commands (use the menus) and
> exchange data, which can probably be done without using the mouse. Since
> none of that probably have anything to do with CygWin they could be and
> should be discussed in a Windows programming group. I have a collection of
> resources about Windows Hooks in my web site at:
>
> http://www.cpp.atfreeweb.com/Hooks.html

You can also use a tool like MSVC's Spy++ to record the events sent to the
application, and then replay them at the application.  I vaguely remember
doing something like this when doing a project on application migration,
when we needed to bring the new instance of the application into the same
state as the original instance, except we used our own dll for that that
intercepted the function calls.  So I know it's doable (but don't ask me
for details :-) ).  You can, of course, edit the stream before replaying
it (if you wish).
	Igor
-- 
				http://cs.nyu.edu/~pechtcha/
      |\      _,,,---,,_		[email-masked]
ZZZzz /,`.-'`'    -.  ;-;;,_		[email-masked]
     |,4-  ) )-,_. ,\ (  `'-'		Igor Pechtchanski
    '---''(_/--'  `-'\_) fL	a.k.a JaguaR-R-R-r-r-r-.-.-.  Meow!

It took the computational power of three Commodore 64s to fly to the moon.
It takes a 486 to run Windows 95.  Something is wrong here. -- SC sig file

--
Unsubscribe info:      http://cygwin.com/ml/#unsubscribe-simple
Bug reporting:         http://cygwin.com/bugs.html
Documentation:         http://cygwin.com/docs.html
FAQ:                   http://cygwin.com/faq/